From 146df8f6586071d22691bae9f7212dc729beb051 Mon Sep 17 00:00:00 2001
From: Paul Zhang <paulz@qti.qualcomm.com>
Date: Mon, 8 Jun 2020 13:50:34 +0800
Subject: [PATCH 62/63] cfg80211: Adjust 6ghz frequencies per channelization

Per 11ax draft 6.1, 6ghz frequencies need adjustment. Also orphan
channel of frequency 5935MHz has been added. Mofify utilities
accordingly.

Signed-off-by: Paul Zhang <paulz@qti.qualcomm.com>
Signed-off-by: Kang Xu <kangxu@codeaurora.org>
---
 net/wireless/util.c | 14 +++++++++-----
 1 file changed, 9 insertions(+), 5 deletions(-)

diff --git a/net/wireless/util.c b/net/wireless/util.c
index 18e1cc234ae0..902abaa748b9 100644
--- a/net/wireless/util.c
+++ b/net/wireless/util.c
@@ -93,8 +93,10 @@ int ieee80211_channel_to_frequency(int chan, enum nl80211_band band)
 		break;
 	case NL80211_BAND_6GHZ:
 		/* see 802.11ax D4.1 27.3.22.2 */
-		if (chan <= 253)
-			return 5940 + chan * 5;
+		if (chan == 2)
+			return 5925 + chan * 5;
+		if (chan <= 233)
+			return 5950 + chan * 5;
 		break;
 	case NL80211_BAND_60GHZ:
 		if (chan < 7)
@@ -116,11 +118,13 @@ int ieee80211_frequency_to_channel(int freq)
 		return (freq - 2407) / 5;
 	else if (freq >= 4910 && freq <= 4980)
 		return (freq - 4000) / 5;
-	else if (freq < 5945)
+	else if (freq < 5925)
 		return (freq - 5000) / 5;
+	else if (freq < 5935)
+		return (freq - 5925) / 5;
 	else if (freq <= 45000) /* DMG band lower limit */
-		/* see 802.11ax D4.1 27.3.22.2 */
-		return (freq - 5940) / 5;
+		/* see 802.11ax D6.1 27.3.22.2 */
+		return (freq - 5950) / 5;
 	else if (freq >= 58320 && freq <= 70200)
 		return (freq - 56160) / 2160;
 	else
-- 
2.17.1

